Subject: bug#45068: [PATCH] 28.0.50; Update Modus themes 1.0.2 (backward-incompatible)

From: Protesilaos Stavrou <[email-masked]>
Date: Fri, 05 Mar 2021 19:34:21 +0200

On 2021-03-05, 17:11 +0000, "Basil L. Contovounesios" <[email-masked]> wrote:

> Protesilaos Stavrou <[email-masked]> writes:
>
>> On 2021-03-04, 19:06 -0300, Mauro Aranda <[email-masked]> wrote:
>>
>>> But if you plan to keep distributing them as packages via ELPA, then
>>> it might make sense to keep it.  I don't know what's the plan, so I
>>> can't say for sure if the form should stay or not.
>>
>> My original plan was to update the themes in emacs.git and then figure
>> out what needs to be done for elpa.git to treat them as ":core" packages
>> instead of ":external".
>>
>> So I had this and would have used a similar technique for the
>> above-quoted code:
>>
>>     (if (and (>= emacs-major-version 28)
>>              (functionp 'require-theme))
>>           (require-theme 'modus-themes)
>>         (require 'modus-themes))
>>
>> But that produced a major bug of not loading the desired theme in
>> certain setups.[1] I suspect it is because 'require' needs to be at the
>> top level?  Not sure...  Maybe there is some clean way to fix that,
>> though I would need more time to research and test it; a time frame that
>> I cannot estimate right now.
>>
>> [1]: <https://gitlab.com/protesilaos/modus-themes/-/issues/162>.
>>
>> So I prefer to use files that 100% work in emacs.git and then I will
>> treat elpa.git separately.  Using all those untested conditional clauses
>> will give me trouble.  Perhaps the themes in elpa.git should not be
>> ":core" after all?  Keeping them as ":external", though updated to the
>> newest release, seems like the most reliable path forward.
>>
>> Ultimately this means more work for me, though I prefer to not have to
>> deal with packaging-related bugs (notwithstanding the fact that I need
>> to ask for someone else to push changes for me in Emacs/ELPA and I would
>> rather not bother them).
>
> Ultimately it's your decision as the maintainer, but after addressing
> the issue you reference above in modus-themes.git, I no longer see any
> significant hurdles to keeping modus-themes.git / elpa.git / emacs.git
> in sync, unless I'm missing something?

In principle I want to keep everything in sync.  I think things should
work now, thanks to your contributions.

I need to prepare the elpa.git patch separately though, as I have not
yet studied exactly what needs to be changed.

>> I appreciate your contributions ("your" singular and plural).  For me
>> this is all part of a learning process and am happy to be part of a
>> community that (i) tolerates my errors and (ii) helps me learn through
>> them without making any discounts on technical requirements.
>
> That should/does apply to everyone here :).

Very well!

-- 
Protesilaos Stavrou
protesilaos.com